package de.uni_passau.fim.strategies;

public class RandomGuessIterator implements IGuessIterator {

	
	int mNumOfColors;
	int mNumOfPlaces;
	boolean mWithRepetition;
	
	
	int mSize;
	int mCurrPos;
	
	public RandomGuessIterator(int numOfColors, int numOfPlaces, boolean withRepetition, int numberOfGames) {
		mNumOfColors = numOfColors;
		mNumOfPlaces = numOfPlaces;
		mWithRepetition = withRepetition;
		if (!Utils.isValidCPRCombination(mNumOfColors, mNumOfPlaces, mWithRepetition) || numberOfGames < 0)
			mSize = 0;
		else
			mSize = numberOfGames;
		mCurrPos = 0;
	}
	
	public boolean hasNext() {
		
		return mCurrPos < mSize;
	}

	public Guess next() {
		if (!hasNext())
			return null;
		mCurrPos++;
		return Utils.createRandomGuess(mNumOfColors, mNumOfPlaces, mWithRepetition);
	}

	public int size() {
		return mSize;
	}

	public int currPos() {
		return mCurrPos;
	}

}
