package de.uni_passau.fim.strategies;

import java.util.HashMap;
import java.util.Map;

public class StrategyFactory {

	private static String[] availableStrategies = {
			"de.uni_passau.fim.strategies.StupidStrategy",
			"de.uni_passau.fim.strategies.InfiniteStrategy"
		};
	
	private static Map<String, IStrategy> strategies = new HashMap<String, IStrategy>();
	
	private static StrategyFactory instance;
	
	private StrategyFactory() {
		init();
	}
	
	
	public static StrategyFactory getInstance() {
		if (instance == null)
			instance = new StrategyFactory();
		return instance;
	}
	
	public void init() {
		for (String s : availableStrategies	) {
			try {
				IStrategy newS = (IStrategy) Class.forName(s).newInstance();
				registerStrategy(newS.getUniqueName(), newS);
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	public void registerStrategy(String key, IStrategy s) {
		System.out.println("Registering " + key);
		strategies.put(key, s);
	}
	
	public IStrategy getStrategy(String key) {
		return strategies.get(key);
	}
	
	public String[] getUniqueStrategyNames() {
		String[] names = new String[strategies.size()];
		System.out.println("LL: " + names.length);
		names = (String[]) (strategies.keySet().toArray(names));
		return names;
	}
	
}
